/*
  ><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

  Display Yin-Yang grid

  - Code distribution: 2013.09.14

  - I hope this code is helpful for your study.

  - Please do not remove my comments.

  - Please send me your feedback to:
  Hiroshi Hayashi
*/
/*><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
  <><><><><>
  main.cpp
          2013.08.08: Created by Hiroshi Hayashi
          2013.09.16  Add viewOperation class
          2013.09.16  Delete snapshot and trackball
          2013.09.20  Delete output inner coordinate
  ><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
*/
#include<iostream>
#include<fstream>
#include<vector>
#include<GLUT/glut.h>
#include"obj.hpp"
#include "iViewOperation.hpp"
#include "viewOperation.hpp"

// Make sure the following three numbers are
// exactly the same as the output 
// of the ../make_avs_data/'s exec command.

#define NR 10
#define NT 24
#define NP 63

//Delete on 2013.09.20 by Hiroshi Hayashi
/*
#define NX 16 
#define NY 16
#define NZ 16
*/

#define NIL 200

using namespace std;

typedef struct{
  double x;
  double y;
  double z;
}myPoint;

vector< vector< vector<myPoint> > > coords_yin,coords_yng;

vector< vector< vector<myPoint> > > coords_inn;


object torus;

GLfloat white[] = { 1.0, 1.0, 1.0, 1.0 };
GLfloat red[]   = { 1.0, 0.078, 0.576, 1.0 };
GLfloat green[] = { 0.596, 0.984, 0.596, 1.0 };
GLfloat blue[]  = { 0.0, 0.749, 1.0, 1.0 };

GLfloat light0pos[] = {1.0,1.0,1.0,0.0};

iViewOperation* vo;

void coords_allocate();
void coords_allocate(vector< vector< vector<myPoint> > >& coords_array,int i_limit,int j_limit, int k_limit);

void display();

void draw_grid();
void draw_inner_grid(vector< vector< vector<myPoint> > > coords_inner);
void draw_outer_grid(vector< vector< vector<myPoint> > > coords_outer);

void init(void);

void my_input();
void my_input(vector< vector< vector<myPoint> > >& array,
              string filename_x,string filename_y,string filename_z,
              int k_limit,int j_limit,int i_limit);

void resize(int w,int h);

void substitue_array(myPoint start,myPoint end,double start_array[],double end_array[]); 

void viewChange(void);

void coords_allocate(){
  //Delete on 2013.09.20 by Hiroshi Hayashi
  //coords_allocate(coords_inn,NX,NY,NZ);
  coords_allocate(coords_yin,NR,NT,NP);
  coords_allocate(coords_yng,NR,NT,NP);
}

void coords_allocate(vector< vector< vector<myPoint> > >& coords_array,
                     int i_limit,int j_limit,int k_limit){
  coords_array.resize(i_limit);
  for(int i=0;i<i_limit;i++){
    coords_array[i].resize(k_limit);
    for(int j=0;j<k_limit;j++){
      coords_array[i][j].resize(k_limit);
    }
  }
}


void display(){
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0,GL_POSITION,light0pos);
  glPushMatrix();
  {
    vo->viewChange();
    draw_grid();
  }
  glPopMatrix();
  glutSwapBuffers();
  glDisable(GL_LIGHTING);
  glDisable(GL_LIGHT0);
}

void draw_grid(){
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, red);
  draw_outer_grid(coords_yin);
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, green);
  draw_outer_grid(coords_yng);
  //  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, blue);
  //  draw_inner_grid(coords_inn);
}

//Delete on 2013.09.20 by Hiroshi Hayashi
/*
void draw_inner_grid(vector< vector <vector <myPoint> > > coords_inner){
  double start[3],end[3];
  for(int i=0;i<NX;i++){
    for(int j=0;j<NY;j++){
      for(int k=0;k<NZ;k++){
        if(coords_inner[i][j][k].x > NIL){
          continue;
        }
        if(i!=0&&coords_inner[i-1][j][k].x < NIL){
          substitue_array(coords_inner[i][j][k],
                          coords_inner[i-1][j][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(i!=NX-1&&coords_inner[i+1][j][k].x < NIL){
          substitue_array(coords_inner[i][j][k],
                          coords_inner[i+1][j][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }
                              
        if(j!=0&&coords_inner[i][j-1][k].x < NIL){
          substitue_array(coords_inner[i][j][k],
                          coords_inner[i][j-1][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(j!=NY-1&&coords_inner[i][j+1][k].x < NIL){

          substitue_array(coords_inner[i][j][k],
                          coords_inner[i][j+1][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(k!=0&&coords_inner[i][j][k-1].x < NIL){
          substitue_array(coords_inner[i][j][k],
                          coords_inner[i][j][k-1],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(k!=NZ-1&&coords_inner[i][j][k+1].x<NIL){
          substitue_array(coords_inner[i][j][k],
                          coords_inner[i][j][k+1],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }
      }
    }
  }
}
*/

void draw_outer_grid(vector< vector< vector<myPoint> > > coords_outer){
  double start[3],end[3];
  for(int i=0;i<NR;i++){
    for(int j=0;j<NT;j++){
      for(int k=0;k<NP;k++){
        if(k!=NP-1){

          substitue_array(coords_outer[i][j][k],
                          coords_outer[i][j][k+1],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(k!=0){
          substitue_array(coords_outer[i][j][k],
                          coords_outer[i][j][k-1],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(j!=NT-1){
          substitue_array(coords_outer[i][j][k],
                          coords_outer[i][j+1][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(j!=0){
          substitue_array(coords_outer[i][j][k],
                          coords_outer[i][j-1][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }
                                        
        if(i!=NR-1){
          substitue_array(coords_outer[i][j][k],
                          coords_outer[i+1][j][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }

        if(i!=0){
          substitue_array(coords_outer[i][j][k],
                          coords_outer[i-1][j][k],
                          start,
                          end);
          torus.drawClynder(start,end,0.005);
        }
                                
      }

    }
  }
}

void init(void){
  coords_allocate();
  my_input();
  torus.init();        
        
  glClearColor(1.0,1.0,1.0,1.0);
  glEnable(GL_DEPTH_TEST);

  glEnable(GL_FOG);
  glFogfv(GL_FOG_COLOR , white);
  glFogi(GL_FOG_MODE , GL_LINEAR);
  glFogf(GL_FOG_DENSITY,0.35);
  glFogi(GL_FOG_HINT , GL_NICEST);
  glFogi(GL_FOG_START , 4.0);
  glFogi(GL_FOG_END , 6);

  vo = new viewOperation();
}

void special_key(int key, int x, int y)
{
  vo->selectSpecialKeys(key,x,y);
}

void keyboard(unsigned char key, int x, int y)
{

  vo->selectKeys(key,x,y);
}

void my_input(){

  // Delete on 2013.09.20 by Hiroshi Hayashi
  /*
  my_input(coords_inn,"coords_x_cube_inner_core_ascii",
           "coords_y_cube_inner_core_ascii",
           "coords_z_cube_inner_core_ascii",NZ,NY,NX);
  */
  my_input(coords_yin,"coords_x_3d_yin_ascii","coords_y_3d_yin_ascii","coords_z_3d_yin_ascii",NP,NT,NR);
  my_input(coords_yng,"coords_x_3d_yng_ascii","coords_y_3d_yng_ascii","coords_z_3d_yng_ascii",NP,NT,NR);
}


void my_input(vector< vector< vector<myPoint> > >& array,
              string filename_x,string filename_y,string filename_z,
              int k_limit,
              int j_limit,
              int i_limit){
  ifstream ifs;
  int i=0,j=0,k=0;
  double x;
  ifs.open(filename_x.c_str());
  for(int k=0;k<k_limit;k++){
    for(int j=0;j<j_limit;j++){
      for(int i=0;i<i_limit;i++){
        ifs >>  array[i][j][k].x;
      }
    }
  }
  ifs.close();

  ifs.clear();
  ifs.open(filename_y.c_str());
  for(int k=0;k<k_limit;k++){
    for(int j=0;j<j_limit;j++){
      for(int i=0;i<i_limit;i++){
        ifs >>  array[i][j][k].y;
      }
    }
  }
  
  ifs.close();
        
  ifs.clear();
  ifs.open(filename_z.c_str());
  for(int k=0;k<k_limit;k++){
    for(int j=0;j<j_limit;j++){
      for(int i=0;i<i_limit;i++){
        ifs >>  array[i][j][k].z;
      }
    }
  }
  ifs.close();
}

void resize(int w,int h){
  glViewport(0,0,w,h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30.0,(double)w/(double)h,1.0,100.0);

  glMatrixMode(GL_MODELVIEW);
}

void substitue_array(myPoint start,myPoint end,double start_array[],double end_array[]){
  start_array[0] = start.x;
  start_array[1] = start.y;
  start_array[2] = start.z;

  end_array[0] = end.x;
  end_array[1] = end.y;
  end_array[2] = end.z;
} 



int main(int argc, char *argv[] ){
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH) ;

  glutCreateWindow(argv[0]);
  init();
  glutReshapeFunc(resize);
  glutDisplayFunc(display);
  glutSpecialFunc(special_key);
  glutKeyboardFunc(keyboard);

  glutMainLoop();
  return 0;
}
