/*
  ><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

  Display Yin-Yang and Cartesian grid

  - Code distribution: 2013.09.14

  - I hope this code is helpful for your study.

  - Please do not remove my comments.

  - Please send me your feedback to:
  Hiroshi Hayashi
*/
/*><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
  <><><><><>
  viewOperation.cpp
  2013.08.08: Created by Kouhei Yamada
  ><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
*/
#include "viewOperation.hpp"
#include <GLUT/glut.h>
#include <cstdlib>

void viewOperation::selectKeys(unsigned char key, int x , int y){
  double del_z = 0.2;
  switch (key) {
  case 'z':
    trans.Camera_z -= del_z;
    glutPostRedisplay();
    break;
  case 'Z':
    trans.Camera_z += del_z;
    glutPostRedisplay();
    break;
  case 'q':
  case 'Q':
  case '\033':  /* ESC */
    exit(0);
  default:
    break;
  }
}

void viewOperation::selectSpecialKeys(int key ,int x ,int y){
    double del_angle = 2.0;
    double del_horizontal = 0.05;

    switch (key) {
    case GLUT_KEY_UP:
        if ( glutGetModifiers() == GLUT_ACTIVE_SHIFT ) 
          trans.Xrot -= del_angle;
        else
          trans.Camera_y += del_horizontal;
        break;
    case GLUT_KEY_DOWN:
        if ( glutGetModifiers() == GLUT_ACTIVE_SHIFT ) 
          trans.Xrot += del_angle;
        else
          trans.Camera_y -= del_horizontal;
        break;
    case GLUT_KEY_LEFT:
        if ( glutGetModifiers() == GLUT_ACTIVE_SHIFT ) 
          trans.Yrot -= del_angle;
        else
          trans.Camera_x -= del_horizontal;
        break;
    case GLUT_KEY_RIGHT:
        if ( glutGetModifiers() == GLUT_ACTIVE_SHIFT ) 
          trans.Yrot += del_angle;
        else
          trans.Camera_x += del_horizontal;
        break;
    }
   glutPostRedisplay();
}
void viewOperation::viewChange(){
    glTranslated(trans.Camera_x, trans.Camera_y, -trans.Camera_z);
    glRotated(trans.Xrot, 1.0, 0.0, 0.0);
    glRotated(trans.Yrot, 0.0, 1.0, 0.0);
}
