!><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
!
! - Yin-Yang grid cordinate generator
!
!
! - Code distribution: 2013.09.14 
! 
! - I hope this code is helpful for your study.
!
! - Please do not remove my comments.
!
! - Please send me your feedback to:
!              Hiroshi Hayashi
!              Kobe University
!              email: 135x221x@stu.kobe-u.ac.jp
!
!><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>
! make_yyng_avs_data.f90
!              2013.08.08: Created by Kouhei Yamada
!><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

program make_yyng_avs_data

use constants

implicit none

!<< Set grid__rad_min, grid__rad_max >>!
integer, parameter :: n_rad      = 10   ! C_nr  <=- you can change here.
integer, parameter :: n_tht_half = 20   ! C_nt_half  <=  you can change this.
integer, parameter :: SKIP  = 1         ! grid size reduction

real(DP), parameter :: THETA_FROM = PI / 4.0_DP
real(DP), parameter :: THETA_TO   = PI - PI / 4.0_DP
real(DP), parameter :: PHI_FROM   = -(3.0_DP * PI) / 4.0_DP
real(DP), parameter :: PHI_TO     =  (3.0_DP * PI) / 4.0_DP

!----------------- Array ----------------- 
integer, dimension(:), allocatable :: avsgrid__i_skipped
integer, dimension(:), allocatable :: avsgrid__j_skipped
integer, dimension(:), allocatable :: avsgrid__k_skipped

real(SP), dimension(:,:,:), allocatable :: Coords_yin_x
real(SP), dimension(:,:,:), allocatable :: Coords_yin_y
real(SP), dimension(:,:,:), allocatable :: Coords_yin_z

real(SP), dimension(:,:,:), allocatable :: Coords_yng_x
real(SP), dimension(:,:,:), allocatable :: Coords_yng_y
real(SP), dimension(:,:,:), allocatable :: Coords_yng_z

real(SP), dimension(:,:,:), allocatable :: Coords_yin_r
real(SP), dimension(:,:,:), allocatable :: Coords_yin_t
real(SP), dimension(:,:,:), allocatable :: Coords_yin_p

real(SP), dimension(:,:,:), allocatable :: Coords_yng_r
real(SP), dimension(:,:,:), allocatable :: Coords_yng_t
real(SP), dimension(:,:,:), allocatable :: Coords_yng_p

real(SP), dimension(:,:,:), allocatable :: Coords_full_x
real(SP), dimension(:,:,:), allocatable :: Coords_full_y
real(SP), dimension(:,:,:), allocatable :: Coords_full_z

real(DP), dimension(:), allocatable :: grid__rad
real(DP), dimension(:), allocatable :: grid__tht
real(DP), dimension(:), allocatable :: grid__phi
real(DP), dimension(:), allocatable :: grid__sintht
real(DP), dimension(:), allocatable :: grid__costht

real(DP), dimension(:), allocatable :: grid__c_rad
real(DP), dimension(:), allocatable :: grid__c_theta
real(DP), dimension(:), allocatable :: grid__c_phi
real(DP), dimension(:), allocatable :: grid__c_sintht
real(DP), dimension(:), allocatable :: grid__c_costht

real(DP), dimension(:), allocatable :: grid__c_cosphi
real(DP), dimension(:), allocatable :: grid__c_sinphi
!----------------------------------------- 

integer :: n_tht
integer :: n_phi

integer :: c_nr
integer :: c_nt
integer :: c_np

integer :: avsgrid__nr
integer :: avsgrid__nt
integer :: avsgrid__np

integer :: avsgrid__c_nr
integer :: avsgrid__c_nt
integer :: avsgrid__c_np

!- Normalization length
real(DP) :: grid__rad_max
real(DP) :: grid__rad_min

!- delta radius, theta, phi
real(DP) :: grid__drad
real(DP) :: grid__dtht
real(DP) :: grid__dphi

real(DP) :: sinphi, cosphi, sintht, costht

n_tht = n_tht_half + 3
n_phi = n_tht_half * 3 + 3 + 2

c_nr = n_rad
c_nt = 2*n_tht_half
c_np = 2*c_nt

avsgrid__c_nr = c_nr
avsgrid__c_nt = c_nt
avsgrid__c_np = c_np+1

!print *, "avsgrid__c_nr=", avsgrid__c_nr
!print *, "avsgrid__c_nt=", avsgrid__c_nt
!print *, "avsgrid__c_np=", avsgrid__c_np
grid__rad_max = 1.0_DP
grid__rad_min = 0.35_DP

grid__drad = (grid__rad_max - grid__rad_min) / real(n_rad-1, DP)
grid__dtht = (THETA_TO - THETA_FROM) / real(n_tht-3, DP)
grid__dphi = (PHI_TO - PHI_FROM) / real(n_phi-5, DP)


!print *, "grid__rad_max = ", grid__rad_max
!print *, "grid__rad_min = ", grid__rad_min
!print *, "grid__drad = ", grid__drad
!print *, "grid__dtht = ", grid__dtht
!print *, "grid__dphi = ", grid__dphi

allocate( grid__rad(n_rad) )
allocate( grid__tht(n_tht) )
allocate( grid__phi(n_phi) )
allocate( grid__sintht(n_tht) )
allocate( grid__costht(n_tht) )

allocate( grid__c_rad(avsgrid__c_nr) )
allocate( grid__c_theta(avsgrid__c_nt) )
allocate( grid__c_phi(avsgrid__c_np) )

allocate( grid__c_sintht(avsgrid__c_nt) )
allocate( grid__c_costht(avsgrid__c_nt) )

allocate( grid__c_sinphi(avsgrid__c_np) )
allocate( grid__c_cosphi(avsgrid__c_np) )

grid__rad(:) = 0.0_DP
grid__tht(:) = 0.0_DP
grid__phi(:) = 0.0_DP
grid__sintht(:) = 0.0_DP
grid__costht(:) = 0.0_DP

grid__c_rad(:) = 0.0_DP
grid__c_theta(:) = 0.0_DP
grid__c_phi(:) = 0.0_DP

grid__c_sintht(:) = 0.0_DP
grid__c_costht(:) = 0.0_DP

grid__c_sinphi(:) = 0.0_DP
grid__c_cosphi(:) = 0.0_DP

call set_grid_metric

call avsgrid__initialize(n_rad, n_tht, n_phi)

call avsgrid__make_coords(n_rad, n_tht, n_phi)


!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!%%%%%%%%%%%% C O N T A I N S %%%%%%%%%%%%
!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
contains

!---------------Subroutine----------------
    subroutine set_rad(nr)
        integer, intent(in) :: nr

        integer :: i

        allocate( avsgrid__i_skipped(nr) )
        avsgrid__i_skipped(:) = 0
        avsgrid__nr = 0

        do i = 1, nr-1, SKIP
            avsgrid__nr = avsgrid__nr + 1
            avsgrid__i_skipped(avsgrid__nr) = i
        end do

        avsgrid__nr = avsgrid__nr + 1
        avsgrid__i_skipped(avsgrid__nr) = nr

        print *, "avsgrid__nr = ", avsgrid__nr

    end subroutine set_rad
!----------------------------------------- 

!---------------Subroutine----------------
    subroutine set_theta(nt)
        integer, intent(in) :: nt

        integer :: j

        allocate( avsgrid__j_skipped(nt) )
        avsgrid__j_skipped(:) = 0
        avsgrid__nt = 0

! <--start change  130808
!       do j = 2, nt-2, SKIP
!           avsgrid__nt = avsgrid__nt + 1
!           avsgrid__j_skipped(avsgrid__nt) = j
!       end do

        do j = 1, nt, SKIP
            avsgrid__nt = avsgrid__nt + 1
            avsgrid__j_skipped(avsgrid__nt) = j
        end do
! --end change--->

        avsgrid__nt = avsgrid__nt + 1
        avsgrid__j_skipped(avsgrid__nt) = nt-1

        print *, "avsgrid__nt = ", avsgrid__nt

    end subroutine set_theta
!----------------------------------------- 

!---------------Subroutine----------------
    subroutine set_phi(np)
        integer, intent(in) :: np

        integer :: k

        allocate( avsgrid__k_skipped(np) )
        avsgrid__k_skipped(:) = 0
        avsgrid__np = 0

        do k = 2, np-2, SKIP
            avsgrid__np = avsgrid__np + 1
            avsgrid__k_skipped(avsgrid__np) = k
        end do

        avsgrid__np = avsgrid__np + 1
        avsgrid__k_skipped(avsgrid__np) = np-1

        print *, "avsgrid__np = ", avsgrid__np

    end subroutine set_phi
!-----------------------------------------

!---------------Subroutine----------------
    subroutine avsgrid__initialize(nr, nt, np)
        integer, intent(in) :: nr, nt, np

        call set_rad(nr)
        call set_theta(nt)
        call set_phi(np)

    end subroutine avsgrid__initialize
!-----------------------------------------

!---------------Subroutine----------------
    subroutine avsgrid__make_coords(nr, nt, np)
        integer, intent(in) :: nr, nt, np

        real(SP) :: x, y, z ! x, y, z coord, single precision
        real(SP) :: r
        real(DP) :: sinphi, cosphi, sintht, costht

        call iAlloc

        call iCalc_coords
        !call iCalc_coords_full
        call save_3d_coords_ascii
        !call save_3d_coords_binary

        call iDealloc
    
    end subroutine avsgrid__make_coords
!-----------------------------------------


!---------------Subroutine----------------
    subroutine iAlloc
        
        allocate( Coords_yin_x(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yin_y(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yin_z(avsgrid__nr, avsgrid__nt, avsgrid__np) )

        allocate( Coords_yng_x(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yng_y(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yng_z(avsgrid__nr, avsgrid__nt, avsgrid__np) )

        allocate( Coords_yin_r(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yin_t(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yin_p(avsgrid__nr, avsgrid__nt, avsgrid__np) )

        allocate( Coords_yng_r(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yng_t(avsgrid__nr, avsgrid__nt, avsgrid__np) )
        allocate( Coords_yng_p(avsgrid__nr, avsgrid__nt, avsgrid__np) )

        allocate( Coords_full_x(avsgrid__c_nr, avsgrid__c_nt, avsgrid__c_np) )
        allocate( Coords_full_y(avsgrid__c_nr, avsgrid__c_nt, avsgrid__c_np) )
        allocate( Coords_full_z(avsgrid__c_nr, avsgrid__c_nt, avsgrid__c_np) )
        
        Coords_yin_x(:,:,:) = 0.0_SP
        Coords_yin_y(:,:,:) = 0.0_SP
        Coords_yin_z(:,:,:) = 0.0_SP
        
        Coords_yng_x(:,:,:) = 0.0_SP
        Coords_yng_y(:,:,:) = 0.0_SP
        Coords_yng_z(:,:,:) = 0.0_SP

        Coords_yin_r(:,:,:) = 0.0_SP
        Coords_yin_t(:,:,:) = 0.0_SP
        Coords_yin_p(:,:,:) = 0.0_SP

        Coords_yng_r(:,:,:) = 0.0_SP
        Coords_yng_t(:,:,:) = 0.0_SP
        Coords_yng_p(:,:,:) = 0.0_SP

        Coords_full_x(:,:,:) = 0.0_SP
        Coords_full_y(:,:,:) = 0.0_SP
        Coords_full_z(:,:,:) = 0.0_SP

    end subroutine iAlloc
!-----------------------------------------


!---------------Subroutine----------------
    subroutine iCalc_coords
        integer :: i, j, k
        integer :: i_avs, j_avs, k_avs
        real(DP) :: r
        real(DP) :: x, y, z

        do k_avs = 1, avsgrid__np, 1
            k = avsgrid__k_skipped(k_avs)
            sinphi = sin( grid__phi(k) )
            cosphi = cos( grid__phi(k) )

            do j_avs = 1, avsgrid__nt, 1
                j = avsgrid__j_skipped(j_avs)
                sintht = grid__sintht(j)
                costht = grid__costht(j)

                do i_avs = 1, avsgrid__nr, 1
                    i = avsgrid__i_skipped(i_avs)
                    r = grid__rad(i)
                    x = r * sintht * cosphi
                    y = r * sintht * sinphi
                    z = r * costht
                    
                    Coords_yin_x(i_avs, j_avs, k_avs) =  x
                    Coords_yin_y(i_avs, j_avs, k_avs) =  y
                    Coords_yin_z(i_avs, j_avs, k_avs) =  z
                    
                    Coords_yng_x(i_avs, j_avs, k_avs) = -x
                    Coords_yng_y(i_avs, j_avs, k_avs) =  z 
                    Coords_yng_z(i_avs, j_avs, k_avs) =  y

                    Coords_yin_r(i_avs, j_avs, k_avs) = grid__rad(i)
                    Coords_yin_t(i_avs, j_avs, k_avs) = grid__tht(j)
                    Coords_yin_p(i_avs, j_avs, k_avs) = grid__phi(k)

                    Coords_yng_r(i_avs, j_avs, k_avs) = grid__rad(i)
                    Coords_yng_t(i_avs, j_avs, k_avs) = grid__tht(j)
                    Coords_yng_p(i_avs, j_avs, k_avs) = grid__phi(k)

                end do
            end do  
        end do

        !print *, "size of Coords_yin_x=", size(Coords_yin_x)
        !print *, "size of Coords_yin_y=", size(Coords_yin_y)
        !print *, "size of Coords_yin_z=", size(Coords_yin_z)

        !print *, "size of Coords_yng_x=", size(Coords_yng_x)
        !print *, "size of Coords_yng_y=", size(Coords_yng_y)
        !print *, "size of Coords_yng_z=", size(Coords_yng_z)
        !print *, 
        !print *, "size of Coords_yin_r=", size(Coords_yin_r)
        !print *, "size of Coords_yin_t=", size(Coords_yin_t)
        !print *, "size of Coords_yin_p=", size(Coords_yin_p)

        !print *, "size of Coords_yng_r=", size(Coords_yng_r)
        !print *, "size of Coords_yng_t=", size(Coords_yng_t)
        !print *, "size of Coords_yng_p=", size(Coords_yng_p)

    end subroutine iCalc_coords
!----------------------------------------


!---------------Subroutine----------------
    subroutine iDealloc
    
        deallocate( Coords_yin_x )
        deallocate( Coords_yin_y )
        deallocate( Coords_yin_z )

        deallocate( Coords_yng_x )
        deallocate( Coords_yng_y )
        deallocate( Coords_yng_z )

        deallocate( Coords_yin_r )
        deallocate( Coords_yin_t )
        deallocate( Coords_yin_p )
        
        deallocate( Coords_yng_r )
        deallocate( Coords_yng_t )
        deallocate( Coords_yng_p )

        deallocate( Coords_full_x )
        deallocate( Coords_full_y )
        deallocate( Coords_full_z )

    end subroutine iDealloc
!----------------------------------------
    

!---------------Subroutine----------------
    subroutine set_grid_metric

        integer :: i, j, k
        real(DP) :: r, tht
        real(DP) :: c_dtht, c_dphi, ctht, cphi
        integer :: jc, kc
        
        r = 0.0_DP
        tht = 0.0_DP

        do i = 1, n_rad, 1
            r = grid__rad_min + grid__drad*real(i-1, DP)
            
            grid__rad(i) = r
            grid__c_rad(i) = r
        end do

        do j = 1 , n_tht, 1
            tht = THETA_FROM + grid__dtht*(j-2)
            
            grid__tht(j) = tht
            grid__sintht(j) = sin(tht)
            grid__costht(j) = cos(tht)
        end do

        do k = 1, n_phi, 1
            grid__phi(k) = PHI_FROM + grid__dphi*(k-3)
        end do
    !--------------------------------------------------!
        c_dtht = PI / c_nt
        c_dphi = (2.0_DP*PI) / c_np

        do jc = 1, avsgrid__c_nt, 1
            ctht = c_dtht*(jc-0.5_DP)
            grid__c_theta(jc) = ctht
            grid__c_sintht(jc) = sin(ctht)
            grid__c_costht(jc) = cos(ctht)
        end do

        do kc = 1, avsgrid__c_np, 1
            cphi = -PI + c_dphi*(kc-0.5_DP)
            grid__c_phi(kc) = cphi
            grid__c_cosphi(kc) = cos(cphi)
            grid__c_sinphi(kc) = sin(cphi)
        end do
    end subroutine set_grid_metric

!----------------------------------------

!---------------Subroutine---------------
    subroutine iCalc_coords_full
        integer :: ic, jc, kc
        real(DP) :: sintht, costht
        real(DP) :: sinphi, cosphi
        real(DP) :: r, x, y, z

        do kc = 1, avsgrid__c_np, 1
            sinphi = grid__c_sinphi(kc)
            cosphi = grid__c_cosphi(kc)

            do jc = 1, avsgrid__c_nt, 1
                sintht = grid__c_sintht(jc)
                costht = grid__c_costht(jc)

                do ic = 1, avsgrid__c_nr, 1
                    r = grid__c_rad(ic)
                    x = r * sintht * cosphi
                    y = r * sintht * sinphi
                    z = r * costht

                    Coords_full_x(ic,jc,kc) = x
                    Coords_full_y(ic,jc,kc) = y
                    Coords_full_z(ic,jc,kc) = z
                end do
            end do
        end do

        print *, "size of Coords_full_x=", size(Coords_full_x)
        print *, "size of Coords_full_y=", size(Coords_full_y)
        print *, "size of Coords_full_z=", size(Coords_full_z)

    end subroutine iCalc_coords_full

!----------------------------------------

!---------------Subroutine----------------
    subroutine save_3d_coords_ascii

        character(len=20), parameter :: folder = 'coords_ascii/'
       
        integer, parameter :: COORDS_X_3D_YIN_ASCII = 10
        integer, parameter :: COORDS_Y_3D_YIN_ASCII = 11
        integer, parameter :: COORDS_Z_3D_YIN_ASCII = 12

        integer, parameter :: COORDS_X_3D_YNG_ASCII = 13
        integer, parameter :: COORDS_Y_3D_YNG_ASCII = 14
        integer, parameter :: COORDS_Z_3D_YNG_ASCII = 15

        open(COORDS_X_3D_YIN_ASCII, file=trim(folder)//'coords_x_3d_yin_ascii', status='replace')
        open(COORDS_Y_3D_YIN_ASCII, file=trim(folder)//'coords_y_3d_yin_ascii', status='replace')
        open(COORDS_Z_3D_YIN_ASCII, file=trim(folder)//'coords_z_3d_yin_ascii', status='replace')
        
        open(COORDS_X_3D_YNG_ASCII, file=trim(folder)//'coords_x_3d_yng_ascii', status='replace')
        open(COORDS_Y_3D_YNG_ASCII, file=trim(folder)//'coords_y_3d_yng_ascii', status='replace')
        open(COORDS_Z_3D_YNG_ASCII, file=trim(folder)//'coords_z_3d_yng_ascii', status='replace')

            write(COORDS_X_3D_YIN_ASCII, *) Coords_yin_x
            write(COORDS_Y_3D_YIN_ASCII, *) Coords_yin_y
            write(COORDS_Z_3D_YIN_ASCII, *) Coords_yin_z

            write(COORDS_X_3D_YNG_ASCII, *) Coords_yng_x
            write(COORDS_Y_3D_YNG_ASCII, *) Coords_yng_y
            write(COORDS_Z_3D_YNG_ASCII, *) Coords_yng_z

        close(COORDS_X_3D_YIN_ASCII)
        close(COORDS_Y_3D_YIN_ASCII)
        close(COORDS_Z_3D_YIN_ASCII)

        close(COORDS_X_3D_YNG_ASCII)
        close(COORDS_Y_3D_YNG_ASCII)
        close(COORDS_Z_3D_YNG_ASCII)

    end subroutine save_3d_coords_ascii
!----------------------------------------

!---------------Subroutine----------------
    subroutine save_3d_coords_binary

        character(len=20), parameter :: folder = 'coords_binary/'
        character(len=20), parameter :: folder_pole = 'coords_binary_polar/'
        character(len=20), parameter :: folder_full = 'coords_binary_full/'

        integer, parameter :: COORDS_X_3D_YIN_BINARY = 20
        integer, parameter :: COORDS_Y_3D_YIN_BINARY = 21
        integer, parameter :: COORDS_Z_3D_YIN_BINARY = 22

        integer, parameter :: COORDS_X_3D_YNG_BINARY = 23
        integer, parameter :: COORDS_Y_3D_YNG_BINARY = 24
        integer, parameter :: COORDS_Z_3D_YNG_BINARY = 25

        integer, parameter :: COORDS_R_3D_YIN_BINARY = 26
        integer, parameter :: COORDS_T_3D_YIN_BINARY = 27
        integer, parameter :: COORDS_P_3D_YIN_BINARY = 28

        integer, parameter :: COORDS_R_3D_YNG_BINARY = 29
        integer, parameter :: COORDS_T_3D_YNG_BINARY = 30
        integer, parameter :: COORDS_P_3D_YNG_BINARY = 31

        integer, parameter :: COORDS_X_FULL_BINARY = 32
        integer, parameter :: COORDS_Y_FULL_BINARY = 33
        integer, parameter :: COORDS_Z_FULL_BINARY = 34

        open(COORDS_X_3D_YIN_BINARY, file=trim(folder)//'coords_x_3d_yin_binary',   &
            status='replace', form='unformatted')
        open(COORDS_Y_3D_YIN_BINARY, file=trim(folder)//'coords_y_3d_yin_binary',   &
            status='replace', form='unformatted')
        open(COORDS_Z_3D_YIN_BINARY, file=trim(folder)//'coords_z_3d_yin_binary',   &
            status='replace', form='unformatted')

        open(COORDS_X_3D_YNG_BINARY, file=trim(folder)//'coords_x_3d_yng_binary',   &
            status='replace', form='unformatted')
        open(COORDS_Y_3D_YNG_BINARY, file=trim(folder)//'coords_y_3d_yng_binary',   &
            status='replace', form='unformatted')
        open(COORDS_Z_3D_YNG_BINARY, file=trim(folder)//'coords_z_3d_yng_binary',   &
            status='replace', form='unformatted')

        !open(COORDS_R_3D_YIN_BINARY, file=trim(folder_pole)//'coords_r_3d_yin_binary',   &
        !    status='replace', form='unformatted')
        !open(COORDS_T_3D_YIN_BINARY, file=trim(folder_pole)//'coords_t_3d_yin_binary',   &
        !    status='replace', form='unformatted')
        !open(COORDS_P_3D_YIN_BINARY, file=trim(folder_pole)//'coords_p_3d_yin_binary',   &
        !    status='replace', form='unformatted')
        !
        !open(COORDS_R_3D_YNG_BINARY, file=trim(folder_pole)//'coords_r_3d_yng_binary',   &
        !    status='replace', form='unformatted')
        !open(COORDS_T_3D_YNG_BINARY, file=trim(folder_pole)//'coords_t_3d_yng_binary',   &
        !    status='replace', form='unformatted')
        !open(COORDS_P_3D_YNG_BINARY, file=trim(folder_pole)//'coords_p_3d_yng_binary',   &
        !    status='replace', form='unformatted')

        !open(COORDS_X_FULL_BINARY, file=trim(folder_full)//'coords_x_full_binary',       &
        !    status='replace', form='unformatted')
        !open(COORDS_Y_FULL_BINARY, file=trim(folder_full)//'coords_y_full_binary',       &
        !    status='replace', form='unformatted')
        !open(COORDS_Z_FULL_BINARY, file=trim(folder_full)//'coords_z_full_binary',       &
        !    status='replace', form='unformatted')

        !print *, "size=", size(Coords_yin_x)
        write(COORDS_X_3D_YIN_BINARY ) Coords_yin_x
        write(COORDS_Y_3D_YIN_BINARY ) Coords_yin_y
        write(COORDS_Z_3D_YIN_BINARY ) Coords_yin_z

        write(COORDS_X_3D_YNG_BINARY ) Coords_yng_x
        write(COORDS_Y_3D_YNG_BINARY ) Coords_yng_y
        write(COORDS_Z_3D_YNG_BINARY ) Coords_yng_z

        !write(COORDS_R_3D_YIN_BINARY ) Coords_yin_r
        !write(COORDS_T_3D_YIN_BINARY ) Coords_yin_t
        !write(COORDS_P_3D_YIN_BINARY ) Coords_yin_p

        !write(COORDS_R_3D_YNG_BINARY ) Coords_yng_r
        !write(COORDS_T_3D_YNG_BINARY ) Coords_yng_t
        !write(COORDS_P_3D_YNG_BINARY ) Coords_yng_p

        !write(COORDS_X_FULL_BINARY ) Coords_full_x
        !write(COORDS_Y_FULL_BINARY ) Coords_full_y
        !write(COORDS_Z_FULL_BINARY ) Coords_full_z

        close(COORDS_X_3D_YIN_BINARY)
        close(COORDS_Y_3D_YIN_BINARY)
        close(COORDS_Z_3D_YIN_BINARY)

        close(COORDS_X_3D_YNG_BINARY)
        close(COORDS_Y_3D_YNG_BINARY)
        close(COORDS_Z_3D_YNG_BINARY)

        !close(COORDS_R_3D_YIN_BINARY)
        !close(COORDS_T_3D_YIN_BINARY)
        !close(COORDS_P_3D_YIN_BINARY)

        !close(COORDS_R_3D_YNG_BINARY)
        !close(COORDS_T_3D_YNG_BINARY)
        !close(COORDS_P_3D_YNG_BINARY)

        !close(COORDS_X_FULL_BINARY)
        !close(COORDS_Y_FULL_BINARY)
        !close(COORDS_Z_FULL_BINARY)

    end subroutine save_3d_coords_binary
    !----------------------------------------

end program make_yyng_avs_data

